//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color5  Silver
#property indicator_color6  DeepSkyBlue
#property indicator_color7  PaleVioletRed
#property indicator_color8  DimGray
#property indicator_width1  2
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  1
#property indicator_width5  3
#property indicator_style6  STYLE_DOT
#property indicator_style7  STYLE_DOT
#property indicator_style8  STYLE_DASH

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[], double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern int            CCIPeriod              = 50;
extern int            StochPeriod            = 30;
extern int            StochSlowing           =  9;
extern ENUM_STO_PRICE StochPrice             = STO_CLOSECLOSE;
extern int            AtrPeriod              = 30;
extern int            DzLookBackBars         = 70;
extern double         DzStartBuyProbability  = 0.25;
extern double         DzStartSellProbability = 0.25;
extern color          OverSoldColor          = clrLimeGreen; 
extern color          OverBoughtColor        = clrOrange; 

//
//
//
//
//

double cci[];
double cciUpa[];
double cciUpb[];
double cciDna[];
double cciDnb[];
double sli[];
double bli[];
double zli[];
double prices[];
double trend[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(11);
      SetIndexBuffer(0, cciUpa); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,EMPTY,OverSoldColor);
      SetIndexBuffer(1, cciUpb); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,EMPTY,OverSoldColor);
      SetIndexBuffer(2, cciDna); SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,EMPTY,OverBoughtColor);
      SetIndexBuffer(3, cciDnb); SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,EMPTY,OverBoughtColor);
      SetIndexBuffer(4, cci);
      SetIndexBuffer(5, bli);
      SetIndexBuffer(6, sli);
      SetIndexBuffer(7, zli);
      SetIndexBuffer(8, prices);
      SetIndexBuffer(9, trend);
      SetIndexBuffer(10,slope);
         
         //
         //
         //
         //
         //
         
   IndicatorShortName("Dynamic zone CCI of stochastic & atr 2 ("+CCIPeriod+","+StochPeriod+","+StochSlowing+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int start()
{
   int k,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i=limit; i>=0; i--)
      {
         prices[i]  = (iStochastic(NULL,0,StochPeriod,1,StochSlowing,MODE_SMA,StochPrice,MODE_MAIN,i)-50)*iATR(NULL,0,AtrPeriod,i);
         double avg = 0; for(k=0; k<CCIPeriod; k++) avg +=         prices[i+k];      avg /= CCIPeriod;
         double dev = 0; for(k=0; k<CCIPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CCIPeriod;
            if (dev!=0)
                  cci[i] = (prices[i]-avg)/(0.015*dev);
            else  cci[i] = 0;
            
            bli[i] = dzBuyP (cci, DzStartBuyProbability,  DzLookBackBars, Bars, i, 0.0001);
            sli[i] = dzSellP(cci, DzStartSellProbability, DzLookBackBars, Bars, i, 0.0001);
            zli[i] = dzSellP(cci, 0.5,                    DzLookBackBars, Bars, i, 0.0001);
            
         
            //
            //
            //
            //
            //
         
            cciUpa[i] = EMPTY_VALUE;
            cciUpb[i] = EMPTY_VALUE;
            cciDna[i] = EMPTY_VALUE;
            cciDnb[i] = EMPTY_VALUE;
            trend[i]  = trend[i+1];
            slope[i]  = slope[i+1];
               if (cci[i]>sli[i])                  trend[i] =  1;
               if (cci[i]<bli[i])                  trend[i] = -1;
               if (cci[i]>bli[i] && cci[i]<sli[i]) trend[i] =  0;
               if (cci[i]>cci[i+1])                slope[i] =  1;
               if (cci[i]<cci[i+1])                slope[i] = -1;
               if (trend[i]==1)
                  if (slope[i]==1)
                        cciUpa[i] = cci[i];
                  else  cciUpb[i] = cci[i];
               if (trend[i]==-1)
                  if (slope[i]==-1)
                        cciDna[i] = cci[i];
                  else  cciDnb[i] = cci[i];
      }
      return(0);
}